<?php
// DEBUG
//error_reporting(E_ALL);
//ini_set("display_errors", 1);
  
// The line below prevents direct access to this file which may lead to a path disclosure vulnerability
if(!defined('CC_DS')) die('Access Denied');

// our variable with the page in it
$page = strtolower($_GET['_a']);

//Make sure the user is logged in and we have a valid ID
if(is_numeric($GLOBALS['user']->getId())){
	$userID = $GLOBALS['user']->getId();
}else{
	$userID = 0;
}

// Include our functions
$functions = CC_ROOT_DIR.CC_DS.'modules'.CC_DS.'plugins/Europe_VAT/admin/functions.php';
include_once($functions);

// Check license
vat_checkLicense();

// Check our license is valid before we do ANYTHING
if(vat_license_valid_hook() == true){

	// If we are on the eu_VAT page and have a valid userID
	if($page == "eu_vat" && $userID > 0){
	
		// Database Tables 
		$cubecart_table_prefix = $GLOBALS['smarty']->tpl_vars['CONFIG']->value['dbprefix'];
		$table = $cubecart_table_prefix . "CubeCart_customer_membership";	
		$table1 = $cubecart_table_prefix . "CubeCart_customer_group";	
		$table2 = $cubecart_table_prefix . "CubeCart_customer";	
		
		// are we processing a form update?
		if(isset($_POST['vat_number']) && $_POST['vat_number'] != ''){

			// What is the ID of our customer group?
			$sql = "SELECT group_id FROM $table1 WHERE group_name = 'EU Vat Exempt Customers'";
			$query = $GLOBALS['db']->query($sql, false, 0, false);
			
			if($query){
				// We have a result
				$groupID = $query[0]['group_id'];
			}else{
				// No record found! BAD! lets re-add the group
				$sql = "INSERT INTO $table1 (group_name, group_description) VALUES ('EU Vat Exempt Customers', '[DO NOT CHANGE GROUP NAME] Added by the Europe VAT plugin to control which customers are exempt from VAT')";
				$query = $GLOBALS['db']->query($sql, false, 0, false);
				
				// Our INSERT ID!
				$groupID = $GLOBALS['db']->insertid();
			}		
		
			// Does our logged in user already exist in the customer group?
			$sql = "SELECT count(1) as cnt FROM $table WHERE group_id = $groupID AND customer_id = $userID";
			$query = $GLOBALS['db']->query($sql, false, 0, false);
			
			// 1 or 0 for existing user in group
			$user_already_vat_exempt = $query[0]['cnt'];
			
			// Array of valid EU VAT countries, taken from http://www.hmrc.gov.uk/vat/managing/international/esl/country-codes.htm on the 19/09/2013
			// NOTE that GB is not in this array because we will never add a UK based company to the VAT exempt group
			$eu_vat_countries = array(
										"AT",
										"BE",
										"BG",
										"HR",
										"CY",
										"CZ",
										"DK",
										"EE",
										"FI",
										"FR",
										"DE",
										"EL",
										"HU",
										"IE",
										"IT",
										"LV",
										"LT",
										"LU",
										"MT",
										"NL",
										"PL",
										"PT",
										"RO",
										"SK",
										"SI",
										"ES",
										"SE",
										"GB"
									);	
		
			// A new VAT number was submitted, so we should process it as per our usual methods as found in hooks class.user.register_user.inserted / Again.
			$vat_number = $_POST['vat_number'];
			$vat_status = is_vat_valid($vat_number);
			
			if($vat_status != false){
			
				// prep some vars for our update query
				if(isset($vat_status->countryCode)){
					$countryCode = $vat_status->countryCode;
				}else{
					$countryCode = '';
				}
				if(isset($vat_status->vatNumber)){
					$vat_number = $vat_status->vatNumber;
				}else{
					$vat_number = '';
				}			
				if(isset($vat_status->name)){
					$vat_name = addslashes($vat_status->name);
				}else{
					$vat_name = '';
				}
				if(isset($vat_status->address)){
					$vat_address = addslashes($vat_status->address);
				}else{
					$vat_address = '';
				}	
				
				// Figure out if we are going to add this customer to a tax free group based on the following logic
				// UK Customers - Always charged VAT (Never add to VAT free customer group)
				// Non EU (rest of world) customers - Never CHarged VAT (If in a non EU country ADD to VAT free customer group)
				// EU Customers - Charged VAT unless they have supplied a Valid VAT number and then it's Exempt. (IF in EU and VAT number is valid ADD to VAT free customer group)
								
				// Decision variable
				$add_to_customer_group = 0;

				// We alrady know our VAT number is valid, lets check the supplied VAT country code against our list of allowed country codes. If match, then we can add the user to the customer group
				if(in_array(strtoupper($countryCode), $eu_vat_countries)){
					$add_to_customer_group = 1;
				}
				
				// Update the customer record with values we got from the API about the VAT number
				$sql = "UPDATE $table2 SET vat_number = '$vat_number', vat_countryCode = '$countryCode', vat_validated = 1, vat_officialName = '$vat_name', vat_officialAddress = '$vat_address' WHERE customer_id = $userID";
				$query = $GLOBALS['db']->query($sql, false, 0, false);
				
				// Add to customer group?
				if($add_to_customer_group == 1 && $user_already_vat_exempt == 0){
					
					// Customer ID is in the variable $insert
					// Add this customer to the customer group
					$sql = "INSERT INTO $table (group_id, customer_id) VALUES ($groupID, $userID)";
					$query = $GLOBALS['db']->query($sql, false, 0, false);
					
					// Update the customer record with values we got from the API about the VAT number
					$sql = "UPDATE $table2 SET vat_addedToGroup = 1 WHERE customer_id = $userID";
					$query = $GLOBALS['db']->query($sql, false, 0, false);
				
				// end add to customer group?
				}
		
			// end if VAT number is not false
			}else{
				// VAT Number was NOT validated against the API, but was submitted anyway, we should add this to the DB for reference
				
				// Remove the user from the customer group if they exist in it
				if($user_already_vat_exempt == 1){
					// Does our logged in user already exist in the customer group?
					$sql = "DELETE FROM $table WHERE group_id = $groupID AND customer_id = $userID";
					$query = $GLOBALS['db']->query($sql, false, 0, false);
				}
				
				// update query
				$sql = "UPDATE $table2 SET vat_number = '$vat_number', vat_validated = 0, vat_addedToGroup = 0, vat_countryCode = '', vat_officialName = '', vat_officialAddress = '' WHERE customer_id = $userID";
				$query = $GLOBALS['db']->query($sql, false, 0, false);
			}
		}
		
		// BELOW LOADS THE INFO TO SHOW THE USER


		
		// Sql query to lookup the users VAT number 
		$sql = "SELECT vat_countryCode, vat_number, vat_validated FROM $table2 WHERE customer_id = $userID";
		$query = $GLOBALS['db']->query($sql, false, 0, false);
		
		// if our SQL query ran OK
		if($query){
			$vat_cc = $query[0]['vat_countryCode'];
			$vat_num = $query[0]['vat_number'];
			$vat_number = $vat_cc . $vat_num;
			$vat_validated = $query[0]['vat_validated'];
		}else{
			$vat_cc = '';
			$vat_num = '';
			$vat_number = $vat_cc . $vat_num;
			$vat_validated = 0;
		}
		
		// URL for use in the Javascript below
		$url = $GLOBALS['url'] . '/modules/plugins/Europe_VAT/jquery/vat_check.php';
		
		$html = '<div id="order" class="small-12 columns noPad"><div class="small-12 medium-11 large-9 medium-centered columns"><script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.7/jquery.min.js"></script>';
		$html .= '<script type="text/javascript">';
		
		// Javascript
		$html .= '$( document ).ready(function() {';
		
		$html .= '$(\'#register-taxexemptcustomerdetails\').blur(function() {';
		
		$html .= '	$.ajax({';
		$html .= '		type: "GET",';
		$html .= '		dataType: "json",';
		$html .= '		url: "' . $url . '",';
		$html .= '		data: "vat_number=" + $(this).val(),';
		$html .= '		beforeSend: function(html) { ';
		$html .= '			$(\'#vat_status\').attr("src", \'images/icons/spinner.gif\');';
		$html .= '		},';
		$html .= '		success: 	function(json){';
		$html .= '						var status = json.status;';
		$html .= '						if(status == \'Valid\'){';
		$html .= '							$(\'#vat_status\').attr("src", \'images/icons/1.png\');';
		$html .= '						}else{';
		$html .= '							$(\'#vat_status\').attr("src", \'images/icons/0.png\');';
		$html .= '						}';
		$html .= '					},';
		$html .= '		error: 	function(json){';
		$html .= '					$(\'#vat_status\').attr("src", \'images/icons/0.png\');';
		$html .= '				}';
		$html .= '	});';
		$html .= '	});';
		$html .= '});';
		$html .= '</script>';	
		
		$html .= '<div>
					<h2>EU VAT Number</h2>
					<p>Your EU VAT number if applicable</p><br/>
					<form action="' . currentPage() . '" method="post">
					<fieldset>
					<div><label for="register-taxexemptcustomerdetails">' . vat_getConfigOption('europe_vat', 'details_notice') . '</label><span><input type="text" name="vat_number" id="register-taxexemptcustomerdetails" value="' . $vat_cc . $vat_num . '"><img id="vat_status" src="modules/plugins/Europe_VAT/images/1pxtransparent.gif"></span></div><br/>
					</fieldset>
					<fieldset>
					<div><label for="register-taxexemptcustomerdetails">Country Code</label><span><input type="text" value="' . $vat_cc . '" readonly></span></div><br/>
					<div><label for="register-taxexemptcustomerdetails">VAT Number</label><span><input type="text" value="' . $vat_num . '" readonly></span></div><br/>
					<div><label for="register-taxexemptcustomerdetails">VAT Number Validated</label><span><input type="text" value="';
					
		if($vat_validated == 1){
			$html .= 'Yes';
		}else{
			$html .= 'No';
		}
		
		$html .= '" readonly></span></div><br/>
				</fieldset>
				<p><input name="update" type="submit" value="Update" class="button_submit" /></p></div></div>';
		$GLOBALS['smarty']->assign('PAGE_CONTENT', $html);
	}

} // end license check
